<?php

/**
 * autenticacion_publico actions.
 *
 * @package    canon
 * @subpackage autenticacion_publico
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class autenticacion_publicoActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */
            $username = 'sin usuario';
            $whereUserName = ' ';
            if (isset($request['username'])) {
                $username = $request['username'];
                $whereUserName = " AND tab0.username = '" . $request['username'] . "' ";
            }

            $wherePassword = ' ';
            if (isset($request['password'])) {
                $wherePassword = " AND tab0.password = '" . $request['password'] . "' ";
            }
            $cod = " ";
            $whereCodExpediente = ' ';
            if (isset($request['cod_exp'])) {
                $whereCodExpediente = " AND codigo_expediente = upper('" . $request['cod_exp'] . "') ";
                $cod = "upper('" . $request['cod_exp'] . "') ";
            }

            $whereNumDoc = ' ';
            if (isset($request['num_doc'])) {
                $whereNumDoc = " AND tab0.num_doc = '" . $request['num_doc'] . "' ";
            }

            // Solo registra log la primera vez de consulta
            if ($rowStart == 0) {
                //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                $id_ope_bd = 1;
                //obtener id maestro tabla
                $id_mae_bd = CN_TABLE::consultarIdTablaBD('rmn_titulo');
                //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, "Se produjo una autenticación en el módulo público para el número de documento:" . $request['num_doc']);
            }

            //Validar si existe codigo de expediente en la union entre rmn_titulo y rmn_solicitud
            $sql = <<<EOD
select count(*) as count from(

select * from(select distinct

case 
when tab0.cod_exp is null then tab1.id_solicitud
when tab1.codigo_expediente is null then null
else tab1.id_solicitud
end as id_solicitud,

case 
when tab0.cod_exp is null then tab1.codigo_expediente
when tab1.codigo_expediente is null then tab0.cod_exp
else tab0.cod_exp
end as codigo_expediente,

case 
when tab0.cod_exp is null then 1
when tab1.codigo_expediente is null then 0
else 0
end as notifica

from rmn_titulo tab0 full join rmn_solicitud tab1 on tab0.cod_exp=tab1.codigo_expediente)
where codigo_expediente is not null  $whereCodExpediente
order by codigo_expediente 
    
)tabla
EOD;

            $records = CN_TABLE::executeSQL($sql);
            $total_record_count = $records[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
 
select * from(select distinct

case 
when tab0.cod_exp is null then tab1.id_solicitud
when tab1.codigo_expediente is null then null
else tab1.id_solicitud
end as id_solicitud,

case 
when tab0.cod_exp is null then tab1.codigo_expediente
when tab1.codigo_expediente is null then tab0.cod_exp
else tab0.cod_exp
end as codigo_expediente,

case 
when tab0.cod_exp is null then 1
when tab1.codigo_expediente is null then 0
else 0
end as notifica

from rmn_titulo tab0 full join rmn_solicitud tab1 on tab0.cod_exp=tab1.codigo_expediente)
where codigo_expediente is not null  $whereCodExpediente
order by codigo_expediente
 
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart 
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                $not = $records[0]["notifica"];
                $solicitud = $records[0]["id_solicitud"];


                if ($not == 1) {
                    $consulta = "select tab0.*, tab2.codigo_expediente as cod_exp, null as id_titulo from rmn_persona tab0 join rmn_solicitud_persona tab1 on tab0.id_persona=tab1.id_persona join rmn_solicitud tab2 on tab1.id_solicitud=tab2.id_solicitud where 1=1 $whereNumDoc and tab2.codigo_expediente=$cod";
                } else {

                    $consulta = "select tab0.*, tab2.cod_exp, tab2.id_titulo from rmn_persona tab0 join rmn_titulo_persona tab1 on tab0.id_persona=tab1.id_titular join rmn_titulo tab2 on tab1.id_titulo=tab2.id_titulo where 1=1 $whereNumDoc and tab2.cod_exp=$cod";
                }


                //Existe cedula

                $sql = <<<EOD
select count(*) as count from(

$consulta              
                
)tabla
EOD;
                $records = CN_TABLE::executeSQL($sql);
                $total_record_count = $records[0]["count"];

                //validar si hay registros
                if ($total_record_count > 0) {

                    $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

$consulta                    
 
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart 
EOD;

                    //ejecuta y obtiene el resultado del sql
                    $records = CN_TABLE::executeSQL($sql);

                    $titular = $records[0]["id_persona"];
                    $titulo = $records[0]["id_titulo"];
                    $codExp = $request['cod_exp'];
                    $id_usuario = $titular;


                    //asignar id del usuario al autenticar
                    $this->logMessage("[AUTENTICAR-PUBLICO]");
                    $id_usuario = $titular;
                    $records[0] = array();
                    $records[0]["id_titulo"] = $titulo;
                    $records[0]["id_titular"] = $titular;
                    $records[0]["cod_exp"] = $codExp;
                    $records[0]["autenticacion"] = true;


                    $this->logMessage("[AUTENTICAR-PUBLICO] Autenticado.");
                    $this->totalRows = $total_record_count;
                    $this->startRow = $rowStart;
                    $this->endRow = $rowEnd;
                    $this->list_data = $records;
                    $this->status = 0;
                    $this->logMessage("[AUTENTICAR-PUBLICO] Consulta exitosa.");
                } else {

                    $id_usuario = 0;
                    $this->logMessage("[AUTENTICAR-PUBLICO] Login Incorrecto");

                    $this->status = 0;
                    $this->totalRows = 1;
                    $this->startRow = $rowStart;
                    $this->endRow = $rowEnd;
                    $records = array();
                    $records[0] = array();
                    $records[0]["rownum"] = "1";
                    $records[0]["autenticacion"] = false;
                    $this->list_data = $records;
                }
            } else {

                $id_usuario = 0;
                $this->logMessage("[AUTENTICAR-PUBLICO] Login Incorrecto");

                $this->status = 0;
                $this->totalRows = 1;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $records = array();
                $records[0] = array();
                $records[0]["rownum"] = "1";
                $records[0]["autenticacion"] = false;
                $this->list_data = $records;
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
